package aud.exam.prep.tree;

import java.util.Comparator;

public class RecursiveOrderedBinaryTreeNodeProcessor<V> extends OrderedBinaryTreeNodeProcessor<V> {

    @Override
    public boolean find(BinaryTreeNode<V> tree, V v, Comparator<V> cmp) {
        return false;
    }

    @Override
    public boolean override(BinaryTreeNode<V> pointer, V from, V to, Comparator<V> cmp) {
        return false;
    }

    @Override
    public boolean overrideAll(BinaryTreeNode<V> pointer, V from, V to, Comparator<V> cmp) {
        return false;
    }

    @Override
    public BinaryTreeNode<V> insert(BinaryTreeNode<V> tree, V v, Comparator<V> cmp) {
        if (tree == null) {
            tree = new BinaryTreeNode<>();
            tree.key = v;
            return tree;
        }

        var c = cmp.compare(v, tree.key);

        if (c <= 0) {
            tree.left = insert(tree.left, v, cmp);
        } else {
            tree.right = insert(tree.right, v, cmp);
        }

        return tree;
    }

    @Override
    public boolean remove(BinaryTreeNode<V> tree, V v, Comparator<V> cmp) {
        return false;
    }

    @Override
    public boolean removeAll(BinaryTreeNode<V> tree, V v, Comparator<V> cmp) {
        return false;
    }

    @Override
    public V max(BinaryTreeNode<V> tree, Comparator<V> cmp) {
        return null;
    }

    @Override
    public V secondMax(BinaryTreeNode<V> tree, Comparator<V> cmp) {
        return null;
    }

    @Override
    public int height(BinaryTreeNode<V> tree) {
        if (tree == null) {
            return -1;
        }
        return 0;
    }

    @Override
    public boolean isBalanced(BinaryTreeNode<V> tree) {
        if (tree == null) {
            return true;
        }
        return false;
    }

    @Override
    public int numberOfNodes(BinaryTreeNode<V> tree) {
        return 0;
    }

    @Override
    public int numberOfNodesOnLevel(BinaryTreeNode<V> tree, int level) {
        return 0;
    }

    @Override
    public BinaryTreeNode<V> rightmostNodeInLeftSubtree(BinaryTreeNode<V> tree) {
        return null;
    }

    @Override
    public BinaryTreeNode<V> leftmostNodeInRightSubtree(BinaryTreeNode<V> tree) {
        return null;
    }

    @Override
    public BinaryTreeNode<V> invert(BinaryTreeNode<V> tree) {
        return null;
    }

    @Override
    public BinaryTreeNode<V> clone(BinaryTreeNode<V> tree) {
        return null;
    }

    @Override
    public boolean check(BinaryTreeNode<V> tree, Comparator<V> cmp) {
        if (tree == null) {
            return true;
        }

        if (tree.key == null) {
            return false;
        }

        if (tree.left != null) {
            if (!check(tree.left, cmp) || cmp.compare(tree.left.key, tree.key) > 0) {
                return false;
            }
        }

        if (tree.right != null) {
            if (!check(tree.right, cmp) || cmp.compare(tree.right.key, tree.key) < 0) {
                return false;
            }
        }

        return true;
    }
}
